<template>
  <div style="margin-top:100px">
    <div style="padding:10px; text-align:right">
      <el-button
        type="primary"
        @click="getNewLocation"
      >
        Update Route
      </el-button>
      <el-button
        type="primary"
        @click="getBroadcast"
      >
        SOS
      </el-button>
    </div>
    <br>
    <GmapMap
      :center="center"
      :potholecenter="potholeCenter"
      :soscenter="sosCenter"
      :zoom="9"
      set-panel="true"
      style="width:100%;  height: 700px;"
    >
      <GmapMarker
        :key="index"
        v-for="(m, index) in markers"
        :position="m.position"
        :icon="red"
      />
      <GmapMarker
        :key="index"
        v-for="(m, index) in potholeMarkers"
        :position="m.potholeposition"
        :icon="yellow"
      />
      <GmapMarker
        :key="index"
        v-for="(m, index) in sosMarkers"
        :position="m.sosposition"
        :icon="blue"
      />
      <DirectionsRenderer
        travel-mode="DRIVING"
        :origin="startLocation"
        :destination="endLocation"
      />
      <!-- <div id="sidebar" /> -->
    </GmapMap>
    <div id="container">
      <div id="sidebar" />
    </div>
  </div>
</template>

<script>
import axios from 'axios'
import baseUrl from '@/config'
import DirectionsRenderer from '@/router/DirectionsRenderer'
import { gmapApi } from 'vue2-google-maps'

export default {
  name: 'GoogleMap',
  components: {
    DirectionsRenderer
  },
  data () {
    return {
      /** **locallocation*****/
      center: { },
      currentPlace: null,
      markers: [],
      places: [],
      /** **potholelocation****/
      potholeCenter: { },
      potholePlace: null,
      potholeMarkers: [],
      potholePlaces: [],
      /** **SOS Data ****/
      sosCenter: { },
      sosPlace: null,
      sosMarkers: [],
      sosPlaces: [],

      locationDetails: {},
      deviceIP: null,
      startLocation: null,
      endLocation: null,
      /** *marker icons***/
      red: 'http://maps.google.com/mapfiles/kml/paddle/red-circle.png',
      yellow: 'http://maps.google.com/mapfiles/kml/paddle/ylw-circle.png',
      blue: 'http://maps.google.com/mapfiles/kml/paddle/blu-circle.png'
    }
  },
  mounted () {
    this.geolocate()
    this.getMessages()
    this.getSOSData()
    var directionsRenderer = new gmapApi.maps.DirectionsRenderer()
    directionsRenderer.setPanel(document.getElementById('sidebar'))
  },
  methods: {
    getBroadcast () {
      const URL = baseUrl.baseUrl_NodeProxy + '/broadcast'
      let locationDetails = {}
      if (navigator.geolocation) {
        navigator.geolocation.getCurrentPosition(position => {
          locationDetails.lat = position.coords.latitude
          locationDetails.lang = position.coords.longitude
          window.open('https://maps.google.com/?q=' + locationDetails.lat + ',' + locationDetails.lang, '_blank')
          console.log('latlog', locationDetails)
          axios.post(URL, locationDetails).then(response => {
            console.log('res', response.data)
          })
        })
      } else {
        alert('location service not working')
      }
    },
    afterUpdateLocation () {
      if (!this.$route.path.includes('/maps')) {
        this.$router.push('/maps')
      }
    },
    getNewLocation () {
      const URL = baseUrl.baseUrl_NodeProxy + '/update_location'
      axios.get(URL)
        .then(response => {
          console.log('res', response.data)
          this.$notify({
            title: 'Note',
            message: 'Location Updated.'
          })
          this.afterUpdateLocation()
        })
        .catch(error => {
          console.log('err', error.message)
          this.$notify({
            title: 'Note',
            message: 'Connection Issue.'
          })
        })
    },
    /** *currentlocation**/
    setPlace () {
      this.currentPlace = this.center
      console.log('place', this.currentPlace)
      this.addMarker()
    },
    addMarker () {
      if (this.currentPlace) {
        const marker = {
          lat: this.currentPlace.lat,
          lng: this.currentPlace.lng
        }
        this.startLocation = marker
        this.markers.push({ position: marker })
        console.log('llllll', this.markers)
        this.places.push(this.currentPlace)
        console.log('pls', this.places)
        this.center = marker
        this.currentPlace = null
      }
    },
    geolocate: function () {
      navigator.geolocation.getCurrentPosition(position => {
        this.center = {
          lat: position.coords.latitude,
          lng: position.coords.longitude
        }
        this.setPlace()
        console.log('hello', this.center)
      })
    },

    /** ****potholeLocation****/
    setPotholePlace () {
      this.potholePlace = this.potholeCenter
      console.log('potholeplace', this.potholePlace)
      this.addpotholeMarker()
    },
    addpotholeMarker () {
      console.log('loggg', this.potholePlace)
      if (this.potholePlace) {
        const marker = {
          lat: this.potholePlace.lat,
          lng: this.potholePlace.lng
        }
        this.potholeMarkers.push({ potholeposition: marker })
        console.log('opopopo', this.potholeMarkers)
        this.potholePlaces.push(this.potholePlace)
        console.log('olslsls', this.potholePlaces)
        this.potholeCenter = marker
        this.potholePlace = null
      }
    },
    getMessages () {
      // const URL = baseUrl.baseUrl_NodeProxy + '/pothole_data'
      const URL = 'http://localhost:5000/pothole_data'
      axios.get(URL)
        .then(response => {
          for (let x in response.data.potholeData) {
            this.potholeCenter = {
              lat: response.data.potholeData[x].Lattitude,
              lng: response.data.potholeData[x].Longitude
            }
            this.setPotholePlace()
          }
          console.log('potholelocation', this.potholeCenter)
          // setTimeout(function () {
          //   this.getMessages()
          //   this.setPotholePlace()
          // }.bind(this),
          // 3000)
        })
        .catch(error => {
          this.errorMessage = error.message
          this.$notify.error({
            message: 'Error In Getting Messages'
          })
        })
    },
    /** **SOS Location *****/
    setsosPlace () {
      this.sosPlace = this.sosCenter
      console.log('sosplace', this.sosPlace)
      this.addsosMarker()
    },
    addsosMarker () {
      console.log('loggg', this.sosPlace)
      if (this.sosPlace) {
        const marker = {
          lat: this.sosPlace.lat,
          lng: this.sosPlace.lng
        }
        this.endLocation = marker
        this.sosMarkers.push({ sosposition: marker })
        console.log('lplplp', this.sosMarkers)
        this.sosPlaces.push(this.sosPlace)
        console.log('olslsls', this.sosPlaces)
        this.sosCenter = marker
        this.sosPlace = null
      }
    },
    getSOSData () {
      // const URL = baseUrl.baseUrl_NodeProxy + '/sos_data'
      this.deviceIP = localStorage.getItem('DeviceIP')
      console.log('new', this.deviceIP)
      const URL = 'http://localhost:5000/sos_data'
      axios.get(URL)
        .then(response => {
          for (let x in response.data.sosData) {
            if (response.data.sosData[x].clientIP === this.deviceIP) continue
            this.sosCenter = {
              lat: response.data.sosData[x].Lat,
              lng: response.data.sosData[x].Long
            }
            this.setsosPlace()
            // DirectionsRenderer.setPanel(document.getElementById('sidebar'))
          }
          console.log('soslocation', this.sosCenter)
        })
        .catch(error => {
          this.errorMessage = error.message
          this.$notify.error({
            message: 'Error In Getting SOS'
          })
        })
    }
  }
}
</script>
<style scoped lang="less">
#sidebar {
  flex-basis: 15rem;
  flex-grow: 1;
  padding: 1rem;
  max-width: 30rem;
  height: 100%;
  box-sizing: border-box;
  overflow: auto;
  width: 100%;
}
#container {
  height: 100%;
  display: flex;
}
</style>
